<script lang="ts" setup>
import { ref, computed } from 'vue';
import { SEARCH_TYPE, SEARCH_SORT_OPTIONS } from '~/services/search.service';
import { Blog, Docs, Web } from 'slippers-ui/icons';
interface searchResultsPage {
  title: string;
  url: string;
  highlight: {
    body: string;
  };
  body: string;
}
interface searchResultsAsResult {
  records: {
    page: searchResultsPage[];
  };
  info: {
    page: {
      query: string;
      current_page: number;
      num_pages: number;
      per_page: number;
      total_result_count: number;
    };
  };
}
interface searchSortOptions {
  label: string;
  value: string;
  queryValue: string;
}

interface pageContentProps {
  results: {
    label: string;
    sort: string;
  };
  filter: {
    filterText: string;
    sourceText: string;
  };
}
interface SearchResultsProps {
  searchResults: searchResultsAsResult;
  searchFilter: string;
  pageContent: pageContentProps;
}

//Props
const props = defineProps<SearchResultsProps>();

//Emits
const emit = defineEmits(['sort', 'activateFilter']);

//Reactive data
const sortOptions = SEARCH_SORT_OPTIONS.map((item: searchSortOptions) => item.label);
const sortBy = ref(SEARCH_SORT_OPTIONS[0].label);

//Computed data
const totalPages = computed(() => {
  return props.searchResults.info.page.num_pages <= 100 ? props.searchResults.info.page.num_pages : 100;
});
const resultIcon = computed(() => {
  switch (props.searchFilter) {
    case SEARCH_TYPE.HANDBOOK: {
      return Docs;
    }
    case SEARCH_TYPE.BLOG: {
      return Blog;
    }
    default: {
      return Web;
    }
  }
});
const resultLabel = computed(() => {
  if (props.searchFilter === SEARCH_TYPE.HANDBOOK) {
    return SEARCH_TYPE.HANDBOOK;
  }
  if (props.searchFilter === SEARCH_TYPE.MARKETING) {
    return 'about';
  }
  return SEARCH_TYPE.BLOG;
});

//Methods data
const onSort = (value: string) => {
  sortBy.value = value;
  const sortValue =
    SEARCH_SORT_OPTIONS.find((item: searchSortOptions) => sortBy.value === item.label) || SEARCH_SORT_OPTIONS[0];
  emit('sort', sortValue.value);
};
const toggleFilter = () => {
  emit('activateFilter');
};
</script>

<template>
  <div class="search-results">
    <div class="search-results__header">
      <SlpTypography tag="div" variant="heading5-bold" class="search-results__header--title">
        {{ Number(searchResults.info.page.total_result_count).toLocaleString() }}
        {{ pageContent?.results?.label }} "{{ searchResults.info.page.query }}"
      </SlpTypography>
      <div class="search-results__header--sort">
        <SlpTypography tag="label" for="search-sort" variant="body2" class="slp-color-text-200 slp-mr-8 no-mobile"
          >{{ pageContent?.results?.sort }}
        </SlpTypography>

        <SlpDropdown
          id="search-sort"
          v-model="sortBy"
          class="search-results__sort"
          name="sort"
          :options="sortOptions"
          @input="onSort"
        />
        <SlpButton variant="ghost" name="Filter" class="search-results__filter-btn mobile" @click="toggleFilter">{{
          pageContent?.filter?.filterText
        }}</SlpButton>
      </div>
    </div>
    <div class="search-results__content">
      <a
        v-for="(page, index) in searchResults.records.page"
        :key="`${page.title} | ${index}`"
        class="search-results__page slp-color-primary-200"
        :href="page.url"
        data-ga-location="search result"
        :data-ga-name="searchResults.info.page.query"
      >
        <div class="search-results__page--topic">
          <SlpIcon :icon="resultIcon" />
          <SlpTypography tag="h4" variant="body3" class="slp-ml-8 icon-label">
            {{ resultLabel }}
          </SlpTypography>
        </div>
        <SlpTypography class="search-results__page-title" tag="h4" variant="body1-bold">
          {{ page.title }}
        </SlpTypography>
        <SlpTypography class="search-results__description" tag="p" variant="body2">
          <span v-if="page.highlight.body" v-html="page.highlight.body" />
          <span v-else> {{ page.body }} </span>
        </SlpTypography>
      </a>
    </div>
    <SearchPagination
      :current-page="searchResults.info.page.current_page"
      :per-page="searchResults.info.page.per_page"
      :total-pages="totalPages"
      v-bind="$attrs"
      :page-content="pageContent"
    />
  </div>
</template>

<style lang="scss" scoped>
.search-results {
  padding: $spacing-24;

  @media (max-width: $breakpoint-md) {
    padding: 0 $spacing-8;
    overflow-x: hidden;
  }

  &__header {
    display: flex;
    justify-content: space-between;
    padding: $spacing-16 0;
    border-bottom: 1px solid $color-surface-200;
    margin-bottom: $spacing-16;

    @media (max-width: $breakpoint-md) {
      flex-direction: column;
      border: none !important;
      padding: $spacing-8;
    }
    &--title {
      @media (max-width: $breakpoint-md) {
        margin-bottom: $spacing-24;
      }
    }
    &--sort {
      display: flex;
      align-items: center;
      justify-content: space-around;
      @media (max-width: $breakpoint-md) {
        padding-top: $spacing-24;
        border-top: 1px solid $color-surface-200;
      }
    }
  }

  &__sort {
    width: 200px;
    position: relative;
    height: 44px;

    @media (max-width: $breakpoint-md) {
      width: 258px;
    }

    &:after {
      top: $spacing-8 !important;
      right: $spacing-8 !important;
    }

    &:deep(.dropdown__select) {
      height: 44px;
      color: $color-text-200;
      padding: 12px;

      &:focus-visible {
        outline: none;
      }
    }
  }

  &__filter-btn {
    cursor: pointer;
    font-weight: $font-weight-bold !important;
    font-size: 18px;
    color: $color-text-link-100;
    padding: 0 $spacing-8;
  }

  &__content {
    display: flex;
    flex-direction: column;
  }

  &__page {
    padding: $spacing-24;
    border-radius: 4px;
    color: unset;

    &:hover {
      background-color: $color-surface-800;

      .search-results__page-title {
        color: $color-text-link-100;
      }
    }

    @media (max-width: $breakpoint-md) {
      padding: $spacing-16 $spacing-8;
      margin-bottom: $spacing-32;
    }
  }

  &__page,
  &__page-title {
    transition: all 0.4s ease-in-out;
  }

  &__page-title {
    margin-bottom: $spacing-8;

    &:deep(em) {
      color: $color-text-link-100 !important;
    }
  }

  &__page--topic {
    display: flex;
    align-items: center;
    margin-bottom: $spacing-8;

    .icon-label {
      text-transform: capitalize;
    }
  }

  &__description {
    display: -webkit-box;
    overflow: hidden;
    -webkit-line-clamp: 2;
    -webkit-box-orient: vertical;

    &:deep(em) {
      font-weight: $font-weight-bold !important;
      font-style: normal !important;
    }
  }
  .mobile {
    display: none;
    @media (max-width: $breakpoint-md) {
      display: block;
    }
  }
  .no-mobile {
    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }
}
</style>
